## codelite 18.1.0

=== CMakeLists.txt ===
# 3.16 and later is required so we can build CodeLite with PCH
cmake_minimum_required(VERSION 3.16)

# ######################################################################################################################
#
# CodeLite IDE cmake file Typical usage will be (build in release mode):
#
# Linux / macOS:
# -------------------
# ~~~
# mkdir build
# cd build
# cmake -G "Unix Makefiles" -DCMAKE_BUILD_TYPE=Release ..
# make -j$(nproc) install
# ~~~
#
# MSYS2
# -------------------
#
# ~~~
# mkdir build-release
# cd build-release
# cmake -G"MinGW Makefiles" -DCMAKE_BUILD_TYPE=Release .. -DWXWIN=C:/msys64/path/to/wx-dir
# make -j$(nproc)
# ~~~
#
# Optional command line arguments:
#
# -DCMAKE_BUILD_TYPE=Release|Debug|DebugFull -DCOPY_WX_LIBS=1|0 -DPREVENT_WX_ASSERTS=1|0 -DAUTOGEN_REVISION=1|0
# -DWITH_PCH=1|0 -DWITH_NATIVEBOOK=1|0 -DWITH_WXPATH=/path/to/different_wx-config/directory/ -DMAKE_DEB=1|0
# -DENABLE_SFTP=1|0 // When set to 1 codelite is built with SFTP/Remoty support. -DWITH_WX_CONFIG=/path/to/wx-config
#
# Windows / MSYS options:
#
# -DWXWIN=<fullpath>                          // https://docs.codelite.org/build/build_wx_widgets/#windows
# -DWITH_POSIX_LAYOUT // When building under Windows, install CodeLite using POSIX layout
#
# ######################################################################################################################

if(NOT CMAKE_VERSION VERSION_LESS 3.1) # THIS MUST STAY AT THE TOP OF THE FILE
    cmake_policy(VERSION 3.1) # Doing this prevents multiple, very verbose warnings about policy CMP0053 not being set
endif()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")
include(OSXDeps)

# ######################################################################################################################
# Defaults
# ######################################################################################################################
project("CodeLite")

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

option(WITH_CHATAI "Enable ChatAI plugin" OFF)
option(BUILD_TESTING "Build test executables" OFF)

# Set this option to "ON" in order to get CMake standard/expected behavior
set(RETAIN_CACHED_VALUES
    OFF
    CACHE BOOL "Compat option to unset certain cached variables")

if(UNIX AND NOT APPLE)
    if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
        # user did not pass -DCMAKE_INSTALL_PREFIX and this is the first time we are executing cmake, the default is set
        # to /usr/local and we do not want that..
        set(CMAKE_INSTALL_PREFIX
            "/usr"
            CACHE ON "Install prefix" FORCE)
    endif()
endif()

if(MINGW)
    set(CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/install")
    set(CL_PREFIX "${CMAKE_INSTALL_PREFIX}")
    if(NOT DEFINED ENV{MSYS2_BASE})
        message(
            FATAL_ERROR
                "Set the environment variable MSYS2_BASE to point to the installation of your MSYS2. e.g. export MSYS2_BASE=C:/msys64"
        )
    endif()
    set(MSYS2_BASE $ENV{MSYS2_BASE})
elseif(UNIX AND NOT APPLE)
    if(CL_PREFIX)
        # user provided CL_PREFIX -> use it instead of CMAKE_INSTALL_PREFIX
        set(CMAKE_INSTALL_PREFIX "${CL_PREFIX}")
    else()
        # update CL_PREFIX to CMAKE_INSTALL_PREFIX
        set(CL_PREFIX "${CMAKE_INSTALL_PREFIX}")
    endif()
endif()

message(STATUS "CMAKE_INSTALL_PREFIX is set to ${CMAKE_INSTALL_PREFIX}")
set(CODELITE_VERSION "18.1.0")

# for now, we keep wxCrafter version to be the same as CodeLite version this allows for better support
set(WXCRAFTER_VERSION ${CODELITE_VERSION})

# Generate compile_commands.json file for code completion
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)
set(CL_SRC_ROOT ${CMAKE_CURRENT_LIST_DIR})

include(UtilsHelper)
find_package(SQLite3)

if(NOT SQLite3_FOUND)
    if(UNIX)
        message(FATAL_ERROR " **** Could not find sqlite3. Please install libsqlite3-dev package")
    elseif(APPLE)
        message(FATAL_ERROR " **** Could not find sqlite3. Please install Sqlite3 via brew")
    elseif(MINGW)
        message(
            FATAL_ERROR
                " **** Could not find sqlite3. Please install sqlite3 package: pacman -S mingw-w64-clang-x86_64-sqlite3"
        )
    else()
        message(FATAL_ERROR " **** Could not find sqlite3. Please install sqlite3 development package")
    endif()
endif()

find_package(BISON REQUIRED)

if(NOT BISON_FOUND)
    if(UNIX)
        message(FATAL_ERROR " **** Could not find flex. Please install bison package")
    elseif(APPLE)
        message(FATAL_ERROR " **** Could not find flex. Please install bison")
    elseif(MINGW)
        message(FATAL_ERROR " **** Could not find flex. Please install bison package: pacman -S bison")
    else()
        message(FATAL_ERROR " **** Could not find bison. Please install bison package")
    endif()
endif()

find_package(FLEX REQUIRED)

if(NOT FLEX_FOUND)
    if(UNIX)
        message(FATAL_ERROR " **** Could not find flex. Please install flex package")
    elseif(APPLE)
        message(FATAL_ERROR " **** Could not find flex. Please install flex")
    elseif(MINGW)
        message(FATAL_ERROR " **** Could not find flex. Please install flex package: pacman -S flex")
    else()
        message(FATAL_ERROR " **** Could not find flex. Please install flex package")
    endif()
endif()

set(IS_FREEBSD 0)
if(CMAKE_SYSTEM_NAME MATCHES "^.*BSD$|DragonFly")
    set(IS_FREEBSD 1)
    add_definitions(-D_BSD_SOURCE -DFREEBSD)
endif()
set(IS_NETBSD 0)
set(BUILD_WXC 0)
set(CL_COPY_WX_LIBS 0)
set(WITH_SFTP 1)

# Create the post_install.cmake script (no append here)
write_file("${CMAKE_BINARY_DIR}/post_install.cmake" "message(STATUS \"Running post install script\")")

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-declarations") # Avoid very multiple warnings spam due to
                                                                       # deprecated wx methods
if(UNIX AND NOT APPLE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -isystem /usr/include/harfbuzz -isystem /usr/local/include/harfbuzz"
    )# Needed for fedora 31 so far, but will spread. See https://gitlab.kitware.com/cmake/cmake/issues/19531
endif()

if(UNIX
   AND NOT APPLE
   AND NOT CYGWIN)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--disable-new-dtags")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--disable-new-dtags")
endif()

if(UNIX)
    # Configure CCache if available
    find_program(CCACHE_FOUND ccache)
    if(CCACHE_FOUND)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
    endif(CCACHE_FOUND)
endif(UNIX)

if(UNIX)
    set(BUILD_DIRECTORY ${CMAKE_BINARY_DIR})
elseif(MINGW)
    set(BUILD_DIRECTORY ${CMAKE_BINARY_DIR})
else()
    set(BUILD_DIRECTORY $ENV{CD})
endif()

message("-- BUILD_DIRECTORY is set to ${BUILD_DIRECTORY}")

set(OS_NAME "WIN")
if(UNIX)
    execute_process(
        COMMAND uname -s
        OUTPUT_VARIABLE OS_NAME
        OUTPUT_STRIP_TRAILING_WHITESPACE)
endif()
message("-- OS name ${OS_NAME}")

if(APPLE)
    set(WX_COMPONENTS "std aui propgrid ribbon")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
else(APPLE)
    set(WX_COMPONENTS "std aui propgrid stc ribbon richtext")
endif()

# Appstream metadata
set(METAINFO_FILE "${CMAKE_SOURCE_DIR}/Runtime/org.codelite.codelite.metainfo.xml")
install(FILES ${METAINFO_FILE} DESTINATION share/metainfo)

if(WITH_WXPATH)
    set(ENV{PATH} ${WITH_WXPATH}:$ENV{PATH})
endif()
if(NOT RETAIN_CACHED_VALUES)
    unset(WITH_WXPATH CACHE)
endif()

if(WITH_WX_CONFIG)
    set(CL_WX_CONFIG ${WITH_WX_CONFIG})
else(WITH_WX_CONFIG)
    set(CL_WX_CONFIG wx-config)
endif()

if(UNIX AND NOT MINGW)
    execute_process(
        COMMAND which ${CL_WX_CONFIG}
        OUTPUT_VARIABLE WX_TOOL
        OUTPUT_STRIP_TRAILING_WHITESPACE)
    if(NOT WX_TOOL)
        message(
            FATAL_ERROR
                "\nNo functional wx_config script was found in your PATH.\nIs the wxWidgets development package installed?"
        )
    else()
        # cmake find_package() will try env var WX_CONFIG as wx-config tool path before checking its builtin hardcoded
        # naming conbinations for wx-config tool
        set(ENV{WX_CONFIG} ${WX_TOOL})
        execute_process(
            COMMAND sh ${WX_TOOL} --version
            OUTPUT_VARIABLE WX_VERSION
            OUTPUT_STRIP_TRAILING_WHITESPACE)
        if("${WX_VERSION}" VERSION_LESS "3.1.6")
            message(
                FATAL_ERROR
                    "I'm afraid your wxWidgets version is too old.\nBuilding CodeLite requires at least wxWidgets-3.1.6"
            )
        endif()
        if(MINGW)
            execute_process(
                COMMAND sh ${WX_TOOL} --debug=no --rescomp
                OUTPUT_VARIABLE WX_RC_FLAGS
                OUTPUT_STRIP_TRAILING_WHITESPACE)
            string(REGEX REPLACE "windres" "" WX_RC_FLAGS ${WX_RC_FLAGS})
            set(CMAKE_RC_FLAGS "${CMAKE_RC_FLAGS} ${WX_RC_FLAGS}")
            add_definitions(-D__WXMSW__)
        endif(MINGW)
    endif()
    message("-- wx-config used is: ${WX_TOOL}")
    message("-- wxWidgets version is: ${WX_VERSION}")
    if(NOT APPLE AND NOT MINGW)
        # Is the wx we are using built on gtk2 or 3?
        execute_process(
            COMMAND ${WX_TOOL} --selected_config
            OUTPUT_VARIABLE WX_GTK_VERSION
            OUTPUT_STRIP_TRAILING_WHITESPACE)
        string(SUBSTRING "${WX_GTK_VERSION}" "3" "1" GTK_VERSION)
        message("-- gtk version is: ${GTK_VERSION}")
    endif()
endif()

# ######################################################################################################################
# Override defaults with user input
# ######################################################################################################################

set(CL_INSTALL_LIBDIR "lib")

if(NOT MINGW)
    if(NOT CL_PREFIX)
        # If the caller hasn't set his own destination, install to a multi-arch lib dir if applicable
        if(CMAKE_VERSION VERSION_GREATER 2.8.7 AND (UNIX AND NOT APPLE))
            if(CMAKE_VERSION VERSION_GREATER 3.0.0)
                # Prior to this, afaict the GNUInstallDirs module worked whatever the prefix Since, it looks at
                # CMAKE_INSTALL_PREFIX which is /usr/local by default, and refuses to run the multiarch-setting code
                # unless it's /usr/ So, partly to comply with the default documented above, & partly for packaging,
                # explicitly set it to /usr
                set(CMAKE_INSTALL_PREFIX "/usr")
            endif()
            include(GNUInstallDirs) # defines CMAKE_INSTALL_LIBDIR to lib or lib64 or whatever. Available since cmake
                                    # 2.8.8
            set(CL_INSTALL_LIBDIR ${CMAKE_INSTALL_LIBDIR})
        endif()

        set(CL_PREFIX "/usr")
    endif(NOT CL_PREFIX)
endif()

# Define the PLUGINS_DIR variable
if(MINGW)
    # MinGW
    set(MINGW_INSTALL_PLUGINS_DIR "${CMAKE_INSTALL_PREFIX}/plugins")
    set(MINGW_INSTALL_BIN "${CMAKE_INSTALL_PREFIX}")
endif()

if(APPLE)
    set(PLUGINS_DIR ${CMAKE_BINARY_DIR}/codelite.app/Contents/SharedSupport/plugins)
    set(CL_INSTALL_BIN ${CMAKE_BINARY_DIR}/codelite.app/Contents/MacOS)
    set(CL_RESOURCES_DIR ${CMAKE_BINARY_DIR}/codelite.app/Contents/SharedSupport)
elseif(MINGW)
    set(PLUGINS_DIR "${MINGW_INSTALL_PLUGINS_DIR}")
    set(CL_INSTALL_BIN "${MINGW_INSTALL_BIN}")
    set(CL_RESOURCES_DIR "${MINGW_INSTALL_BIN}")
else()
    # /usr/lib/codelite
    set(PLUGINS_DIR "${CL_PREFIX}/${CL_INSTALL_LIBDIR}/codelite")
    # /usr/bin
    set(CL_INSTALL_BIN "${CMAKE_INSTALL_PREFIX}/bin")
    # /usr/share/codelite
    set(CL_RESOURCES_DIR "${CMAKE_INSTALL_PREFIX}/share/codelite")
endif()

message(STATUS "CL_INSTALL_BIN is set to ${CL_INSTALL_BIN}")
message(STATUS "PLUGINS_DIR is set to ${PLUGINS_DIR}")

# Try to link-to or build lldb?
if(UNIX)
    set(WITH_LLDB 1)
else()
