=== debian/changelog ===
codelite (18.1.0-1unofficial.trixie) stable; urgency=low

  * Update for the 18.1 release

 -- David Hart <david@codelite.co.uk>  Sat, 18 Jan 2025 10:36:59 +0000

codelite (17.0-1unofficial.bullseye) stable; urgency=low

  * Update for the 17.0 release

 -- David Hart <david@codelite.co.uk>  Sat, 07 Jan 2023 16:55:48 +0000

codelite (16.0-1unofficial.bullseye) stable; urgency=low

  * Update for the 16.0 release

 -- David Hart <david@codelite.co.uk>  Sat, 16 Apr 2022 10:18:05 +0100

codelite (15.0-1unofficial.buster) stable; urgency=low

  * Removed two plugins, Callgraph and ContinuousBuild
  * Multiple fixes and UI changes

 -- David Hart <david@codelite.co.uk>  Wed, 25 Feb 2020 19:35:05 +0000

codelite (14.0-1unofficial3.buster) stable; urgency=low

  * New workspace type: The File System Workspace
  * Multiple UI changes

 -- David Hart <david@codelite.co.uk>  Wed, 25 Feb 2020 19:35:05 +0000
